﻿Imports System.Net.Sockets
Imports System.IO
Imports System.Net

Public Class ClientConnection
    Private ReadOnly _stream As NetworkStream
    Private ReadOnly _streamW As StreamWriter
    Private ReadOnly _streamR As StreamReader
    Private ReadOnly _ipEndPoint As Net.IPEndPoint
    Private ReadOnly _nickName As String

    Public ReadOnly Property Stream() As NetworkStream
        Get
            Return _stream
        End Get
    End Property

    Public ReadOnly Property Writer() As StreamWriter
        Get
            Return _streamW
        End Get
    End Property

    Public ReadOnly Property Reader() As StreamReader
        Get
            Return _streamR
        End Get
    End Property

    Public ReadOnly Property IpAddress() As IPEndPoint
        Get
            Return _ipEndPoint
        End Get
    End Property

    Public ReadOnly Property Nickname() As String
        Get
            Return _nickName
        End Get
    End Property

    Public Overrides Function ToString() As String
        Return _nickName & " (" & _ipEndPoint.ToString() & ")"
    End Function

    Public Sub New(ByVal stream As NetworkStream, ByVal writer As StreamWriter, ByVal reader As StreamReader, ByVal ipAddress As IPEndPoint)
        _stream = stream
        _streamW = writer
        _streamR = reader
        _ipEndPoint = ipAddress
        _nickName = _streamR.ReadLine
    End Sub

    Public Sub New(ByVal stream As NetworkStream, ByVal writer As StreamWriter, ByVal reader As StreamReader, ByVal ipAddress As IPEndPoint, ByVal nickname As String)
        _stream = stream
        _streamW = writer
        _streamR = reader
        _ipEndPoint = ipAddress
        _nickName = nickname
    End Sub
End Class
