﻿Public Class ImportPlayerSettings
    Private delimiterTable As DataTable
    Private _File2Import As String
    Private Headers As DataTable
    Private _PlayerNumberIndex As Integer = Nothing
    Private _PlayerNameIndex As Integer = Nothing
    Private _FileDelimiter As String = Nothing
    Private _FileHasHeaders As Boolean = False
    Public Event SetFile2Import()
    Public Property File2Import() As String
        Get
            Return _File2Import
        End Get
        Set(value As String)
            _File2Import = value
            RaiseEvent SetFile2IMport()
        End Set
    End Property

    Public ReadOnly Property GetPlayerNumberColumnIndex() As Integer
        Get
            Return _PlayerNumberIndex
        End Get
    End Property

    Public ReadOnly Property GetPlayerNameColumnIndex() As Integer
        Get
            Return _PlayerNameIndex
        End Get
    End Property

    Public ReadOnly Property GetFileDelimiter() As String
        Get
            Return _FileDelimiter
        End Get
    End Property

    Public ReadOnly Property FileHasHeaders() As Boolean
        Get
            Return _FileHasHeaders
        End Get
    End Property


    Private Sub ImportPlayerSettings_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        delimiterTable = New DataTable
        With delimiterTable
            .Columns.Add("Text", GetType(String))
            .Columns.Add("Delimiter", GetType(String))
            .Rows.Add("Kommata", ",")
            .Rows.Add("Semicolon", ";")
            .Rows.Add("Pipe", "|")
            .Rows.Add("Tab Stop", vbTab)
        End With
        With ImportDelimiterCB
            .DataSource = delimiterTable
            .DisplayMember = "Text"
            .ValueMember = "Delimiter"
        End With
        AddHandler Me.SetFile2Import, AddressOf ReadFileHEaderline
    End Sub

    Public Sub ReadFileHeaderline()
        Headers = New DataTable()
        Headers.Columns.Add("Text", GetType(String))
        Headers.Columns.Add("Column", GetType(Integer))

        Dim currentRow As String()
        Dim headerRow As Boolean = True
        Using ImportFileReader As New FileIO.TextFieldParser(File2Import)
            ImportFileReader.SetDelimiters(GetFileDelimiter)
            While Not ImportFileReader.EndOfData
                currentRow = ImportFileReader.ReadFields()
                If headerRow = False Then
                    Exit While
                End If
                If headerRow Then
                    For i As Integer = 0 To currentRow.Length - 1
                        Headers.Rows.Add(currentRow(i), i)
                        Debug.WriteLine(currentRow(i), i)
                    Next
                    headerRow = False
                End If
            End While
            Dim playerNameBS As New BindingSource()
            playerNameBS.DataSource = Headers
            Dim playerNumberBS As New BindingSource()
            playerNumberBS.DataSource = Headers
            ComboBox1.DataSource = playerNameBS
            ComboBox1.DisplayMember = "Text"
            ComboBox1.ValueMember = "Column"
            ComboBox2.DataSource = playerNumberBS
            ComboBox2.DisplayMember = "Text"
            ComboBox1.ValueMember = "Column"
        End Using
    End Sub

    Private Sub ImportDelimiterCB_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ImportDelimiterCB.SelectedIndexChanged
        _FileDelimiter = CType(ImportDelimiterCB.SelectedItem, DataRowView).Item(1)
        RaiseEvent SetFile2Import()
    End Sub

    Private Sub ComboBox_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ComboBox1.SelectedIndexChanged, ComboBox2.SelectedIndexChanged
        Dim cb = DirectCast(sender, ComboBox)
        If cb.SelectedIndex > 0 Then
            Dim colIdx As Integer = CType(cb.SelectedItem, DataRowView).Item(1)
            If cb.Name = "ComboBox1" Then
                _PlayerNumberIndex = colIdx
            ElseIf cb.Name = "ComboBox2" Then
                _PlayerNameIndex = colIdx
            End If
        End If
    End Sub

    Private Sub FileHasHeadersCB_CheckedChanged(sender As Object, e As EventArgs) Handles FileHasHeadersCB.CheckedChanged
        _FileHasHeaders = CType(sender, CheckBox).Checked
    End Sub
End Class
