﻿<Serializable()>
Public Class Penalty
    Private ReadOnly _lastID As Integer = 0
    Private ReadOnly _ID As String
    Private _Team As Team
    Private _Number As Integer
    Private _Name As String
    Private _Time As Integer
    Private _Delete As Boolean = False
    Private _GameTime As Integer
    Private ReadOnly _ReentryTime As Integer

    Public Const MIN2_PENALTY = 2 * 60 * 1000
    Public Const MIN4_PENALTY = 4 * 60 * 1000

    Public ReadOnly Property ID() As String
        Get
            Return _ID
        End Get
    End Property

    Public Property PlayerNumber() As Integer
        Get
            Return _Number
        End Get
        Set(value As Integer)
            _Number = value
        End Set
    End Property
    Public Property PlayerName() As String
        Get
            Return _Name
        End Get
        Set(value As String)
            _Name = value
        End Set
    End Property

    Public Property PlayerTeam() As Team
        Get
            Return _Team
        End Get
        Set(value As Team)
            _Team = value
        End Set
    End Property


    Public ReadOnly Property LastID() As Integer
        Get
            Return _lastID
        End Get
    End Property

    Public ReadOnly Property ReentryTime() As Integer
        Get
            Return _ReentryTime
        End Get
    End Property

    Public Property PenaltyTime() As Integer
        Get
            Return _Time
        End Get
        Set(value As Integer)
            _Time = value
        End Set
    End Property

    Public Property DeletePenalty() As Boolean
        Get
            Return _Delete
        End Get
        Set(value As Boolean)
            _Delete = value
        End Set
    End Property

    Public Property GameTime() As Integer
        Set(value As Integer)
            _GameTime = value
        End Set
        Get
            Return _GameTime
        End Get
    End Property

    Public Sub New(ByVal GameTime As Integer, PenaltyTeam As Team, ByVal PlayerNumber As Integer)
        _GameTime = GameTime
        _Team = PenaltyTeam
        _Number = PlayerNumber
        _ID = Guid.NewGuid().ToString
    End Sub

    Public Sub New(ByVal GameTime As Integer, PenaltyTeam As Team, ByVal PlayerNumber As Integer, PlayerName As String)
        _GameTime = GameTime
        _Team = PenaltyTeam
        _Number = PlayerNumber
        _Name = PlayerName
        _ID = Guid.NewGuid().ToString
    End Sub

    Public Sub New(ByVal GameTime As Integer, PenaltyTeam As Team, ByVal PlayerNumber As Integer, PlayerName As String, PenaltyTime As Integer)
        _GameTime = GameTime
        _Team = PenaltyTeam
        _Number = PlayerNumber
        _Name = PlayerName
        _Time = PenaltyTime
        _ReentryTime = PenaltyTime + GameTime
        _ID = Guid.NewGuid().ToString
    End Sub
End Class
