﻿Public Class PenaltyControl
    Private _time, _number As Integer
    Private _name As String

    Public Event OnChangeValues()
    Public Property PenaltyTime As Integer
        Get
            Return _time
        End Get
        Set(value As Integer)
            _time = value
            RaiseEvent onChangeValues()
        End Set
    End Property

    Public Property PlayerNumber As Integer
        Get
            Return _number
        End Get
        Set(value As Integer)
            _number = value
            RaiseEvent onChangeValues()
        End Set
    End Property

    Public Property PlayerName As String
        Get
            Return _name
        End Get
        Set(value As String)
            _name = value
            RaiseEvent onChangeValues()
        End Set
    End Property


    Public Sub New(PlayerNumber As Integer, PenaltyTime As Integer)
        InitializeComponent()
        _number = PlayerNumber
        _time = PenaltyTime
        AddHandler Me.onChangeValues, AddressOf ChangePenaltyUI
        ChangePenaltyUI()
    End Sub

    Public Sub New(PlayerNumber As Integer, PenaltyTime As Integer, PlayerName As String)
        InitializeComponent()
        _number = PlayerNumber
        _time = PenaltyTime
        _name = PlayerName
        AddHandler Me.onChangeValues, AddressOf ChangePenaltyUI
        ChangePenaltyUI()
    End Sub

    Private Sub ChangePenaltyUI()
        Select Case _number
            Case < 10
                With PlayerNumberRightPB
                    .Image = My.Resources.ResourceManager.GetObject("d_" & _number.ToString & "_white")
                End With
                With PlayerNumberLeftPB
                    .Image = My.Resources.ResourceManager.GetObject("d_0_white")
                End With
            Case >= 10
                Dim numberLeft As String = _number.ToString.Substring(0, 1)
                Dim numberRight As String = _number.ToString.Substring(1, 1)
                With PlayerNumberRightPB
                    .Image = My.Resources.ResourceManager.GetObject("d_" & numberRight.ToString & "_white")
                End With
                With PlayerNumberLeftPB
                    .Image = My.Resources.ResourceManager.GetObject("d_" & numberLeft.ToString & "_white")
                End With
        End Select

        Dim Minutes As Integer = 0
        Dim Seconds As Integer = PenaltyTime / 1000
        If (Seconds > 59) Then
            Dim _convTime2Minutes = Seconds / 60
            Minutes = Convert.ToInt16(_convTime2Minutes.ToString.Split(",")(0))
            Seconds -= (Minutes * 60)
        End If
        Select Case Seconds
            Case < 10
                With PenaltySecondRightPB
                    .Image = My.Resources.ResourceManager.GetObject("d_" & Seconds.ToString & "_red")
                End With
                With PenaltySecondLeftPB
                    .Image = My.Resources.ResourceManager.GetObject("d_0_red")
                End With
            Case 10 To 59
                Dim digitLeft = Seconds.ToString.Substring(0, 1)
                Dim digitRight = Seconds.ToString.Substring(1, 1)
                With PenaltySecondRightPB
                    .Image = My.Resources.ResourceManager.GetObject("d_" & digitRight & "_red")
                End With
                With PenaltySecondLeftPB
                    .Image = My.Resources.ResourceManager.GetObject("d_" & digitLeft & "_red")
                End With
        End Select
        Select Case Minutes
            Case < 10
                With PenaltyMinuteRightPB
                    .Image = My.Resources.ResourceManager.GetObject("d_" & Minutes.ToString & "_red")
                End With
                With PenaltyMinuteLeftPB
                    .Image = My.Resources.ResourceManager.GetObject("d_0_red")
                End With
            Case 10 To 60
                Dim digitLeft = Minutes.ToString.Substring(0, 1)
                Dim digitRight = Minutes.ToString.Substring(1, 1)
                With PenaltyMinuteRightPB
                    .Image = My.Resources.ResourceManager.GetObject("d_" & digitRight & "_red")
                End With
                With PenaltyMinuteLeftPB
                    .Image = My.Resources.ResourceManager.GetObject("d_" & digitLeft & "_red")
                End With
            Case Else
                'Throw New IndexOutOfRangeException("Diksplay could show only 60 Minutes or less")
        End Select

        PlayerNameLbl.Text = If((PlayerName = "" Or PlayerName Is Nothing), "Player", PlayerName)
    End Sub
End Class
