﻿Imports System.Linq.Expressions
<Serializable()>
Public Class Player
    Private ReadOnly _ID As String
    Private _Number As Integer
    Private _IsOfficial As Boolean = False
    Private _OfficialNumber As String = Nothing
    Private _Name As String = ""
    Private _Team As Team
    Private ReadOnly _Penalties As List(Of Penalty)
    Private _PlayerWarning As Integer = 0
    Private _Delete As Boolean = False

    Public Enum ChangeStatus As Integer
        AddPlayer
        EditPlayer
        RemovePlayer
    End Enum

    Public ReadOnly Property ID() As String
        Get
            Return _ID
        End Get
    End Property

    Public Property PlayerNumber() As Integer
        Get
            Return _Number
        End Get
        Set(value As Integer)
            _Number = value
        End Set
    End Property
    Public Property PlayerName() As String
        Get
            Return _Name
        End Get
        Set(value As String)
            _Name = value
        End Set
    End Property

    Public Property PlayerTeam() As Team
        Get
            Return _Team
        End Get
        Set(value As Team)
            _Team = value
        End Set
    End Property

    Public ReadOnly Property GetPenalties() As List(Of Penalty)
        Get
            Return _Penalties
        End Get
    End Property

    Public ReadOnly Property CountPenalties() As Integer
        Get
            Return _Penalties.Count
        End Get
    End Property

    Public WriteOnly Property AddPenalty()
        Set(value)
            _Penalties.Add(value)
        End Set
    End Property

    Public ReadOnly Property PlayerWarning() As Integer
        Get
            Return _PlayerWarning
        End Get
    End Property

    Public ReadOnly Property PlayerHasWarning() As Boolean
        Get
            Return _PlayerWarning > 0
        End Get
    End Property

    Public WriteOnly Property SetPLayerWarning() As Integer
        Set(value As Integer)
            _PlayerWarning = value
        End Set
    End Property

    Public Property DeletePlayer() As Boolean
        Get
            Return _Delete
        End Get
        Set(value As Boolean)
            _Delete = value
        End Set
    End Property

    Public Property IsOfficial() As Boolean
        Get
            Return _IsOfficial
        End Get
        Set(value As Boolean)
            _IsOfficial = value
        End Set
    End Property

    Public Property OfficlaNumber() As String
        Get
            Return _OfficialNumber
        End Get
        Set(value As String)
            _OfficialNumber = value
        End Set
    End Property

    Public Sub New(PlayerNumber As Integer)
        _Number = PlayerNumber
        _ID = Guid.NewGuid().ToString
        _Penalties = New List(Of Penalty)
    End Sub

    Public Sub New(PlayerNumber As Integer, PlayerName As String)
        _Number = PlayerNumber
        _Name = PlayerName
        _ID = Guid.NewGuid().ToString
        _Penalties = New List(Of Penalty)
    End Sub

    Public Sub New(PlayerNumber As Integer, PlayerName As String, PlayerTeam As Team)
        _Number = PlayerNumber
        _Name = PlayerName
        _Team = PlayerTeam
        _ID = Guid.NewGuid().ToString
        _Penalties = New List(Of Penalty)
    End Sub

    Public Sub New(PlayerName As String, OfficialNumber As String, PlayerTeam As Team)
        _ID = Guid.NewGuid().ToString
        _Name = PlayerName
        _Penalties = New List(Of Penalty)
        _IsOfficial = True
        _Team = PlayerTeam
        _OfficialNumber = OfficialNumber
    End Sub
End Class
